VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "Form1"
   ClientHeight    =   1065
   ClientLeft      =   1140
   ClientTop       =   1515
   ClientWidth     =   2505
   LinkTopic       =   "Form1"
   PaletteMode     =   1  'UseZOrder
   ScaleHeight     =   1065
   ScaleWidth      =   2505
   Begin VB.TextBox txtSize 
      Height          =   285
      Left            =   240
      TabIndex        =   1
      Top             =   360
      Width           =   975
   End
   Begin VB.CommandButton cmdSetSize 
      Caption         =   "Set Size"
      Height          =   375
      Left            =   1440
      TabIndex        =   0
      Top             =   360
      Width           =   855
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Const HKEY_CLASSES_ROOT = &H80000000
Private Const HKEY_CURRENT_CONFIG = &H80000005
Private Const HKEY_CURRENT_USER = &H80000001
Private Const HKEY_LOCAL_MACHINE = &H80000002
Private Const HKEY_USERS = &H80000003

Private Const REG_SZ = 1 ' Null terminated string

Private Declare Function RegOpenKeyEx Lib "advapi32.dll" Alias "RegOpenKeyExA" (ByVal hKey As Long, ByVal lpSubKey As String, ByVal ulOptions As Long, ByVal samDesired As Long, phkResult As Long) As Long
Private Declare Function RegQueryValueEx Lib "advapi32.dll" Alias "RegQueryValueExA" (ByVal hKey As Long, ByVal lpValueName As String, ByVal lpReserved As Long, lpType As Long, lpData As Any, lpcbData As Long) As Long
Private Declare Function RegCloseKey Lib "advapi32.dll" (ByVal hKey As Long) As Long
Private Declare Function RegSetValueEx Lib "advapi32.dll" Alias "RegSetValueExA" (ByVal hKey As Long, ByVal lpValueName As String, ByVal Reserved As Long, ByVal dwType As Long, lpData As Any, ByVal cbData As Long) As Long         ' Note that if you declare the lpData parameter as String, you must pass it By Value.

Private Const ERROR_SUCCESS = 0&

Private Const STANDARD_RIGHTS_ALL = &H1F0000
Private Const KEY_QUERY_VALUE = &H1
Private Const KEY_SET_VALUE = &H2
Private Const KEY_CREATE_SUB_KEY = &H4
Private Const KEY_ENUMERATE_SUB_KEYS = &H8
Private Const KEY_NOTIFY = &H10
Private Const KEY_CREATE_LINK = &H20
Private Const SYNCHRONIZE = &H100000
Private Const KEY_ALL_ACCESS = _
    ((STANDARD_RIGHTS_ALL Or _
    KEY_QUERY_VALUE Or _
    KEY_SET_VALUE Or _
    KEY_CREATE_SUB_KEY Or _
    KEY_ENUMERATE_SUB_KEYS Or _
    KEY_NOTIFY Or KEY_CREATE_LINK) And _
    (Not SYNCHRONIZE))

Private Declare Function SendMessageTimeout Lib "user32" Alias "SendMessageTimeoutA" (ByVal hwnd As Long, ByVal msg As Long, ByVal wParam As Long, ByVal lParam As Long, ByVal fuFlags As Long, ByVal uTimeout As Long, lpdwResult As Long) As Long
Private Const HWND_BROADCAST = &HFFFF&
Private Const SPI_SETNONCLIENTMETRICS = 42
Private Const SMTO_ABORTIFHUNG = &H2
Private Const WM_WININICHANGE = &H1A
Private Const WM_SETTINGCHANGE = WM_WININICHANGE

' Return a registry key value.
Private Function GetRegKeyValue(ByVal root As Long, ByVal key_name As String, ByVal subkey_name As String) As String
Dim hKey As Long
Dim value As String
Dim length As Long
Dim value_type As Long

    ' Open the key.
    If RegOpenKeyEx(root, key_name, _
        0&, KEY_QUERY_VALUE, hKey) <> ERROR_SUCCESS _
    Then
        MsgBox "Error opening key."
        Exit Function
    End If

    ' Get the subkey's size.
    If RegQueryValueEx(hKey, subkey_name, _
        0&, value_type, ByVal 0&, length) _
            <> ERROR_SUCCESS _
    Then
        MsgBox "Error getting subkey length."
    End If

    ' Get the subkey's value.
    value = Space$(length)
    If RegQueryValueEx(hKey, subkey_name, _
        0&, value_type, ByVal value, length) _
            <> ERROR_SUCCESS _
    Then
        MsgBox "Error getting subkey value."
    Else
        ' Remove the trailing null character.
        GetRegKeyValue = Left$(value, length - 1)
    End If

    ' Close the key.
    If RegCloseKey(hKey) <> ERROR_SUCCESS Then
        MsgBox "Error closing key."
    End If
End Function

' Return a registry key value.
Private Sub SetRegKeyValue(ByVal root As Long, ByVal key_name As String, ByVal subkey_name As String, ByVal subkey_value As String)
Dim hKey As Long
Dim value As String
Dim length As Long
Dim value_type As Long

    ' Open the key.
    If RegOpenKeyEx(root, key_name, _
        0&, KEY_SET_VALUE Or KEY_CREATE_SUB_KEY, _
        hKey) <> ERROR_SUCCESS _
    Then
        MsgBox "Error opening key."
        Exit Sub
    End If

    ' Save the value.
    subkey_value = subkey_value & vbNullChar
    If RegSetValueEx(hKey, subkey_name, 0, _
        REG_SZ, ByVal subkey_value, _
        Len(subkey_value)) <> ERROR_SUCCESS _
    Then
        MsgBox "Error saving value."
        Exit Sub
    End If

    ' Close the key.
    If RegCloseKey(hKey) <> ERROR_SUCCESS Then
        MsgBox "Error closing key."
    End If
End Sub
' Set the icon size.
Private Sub cmdSetSize_Click()
Dim result As Long

    ' Set the icon size.
    SetRegKeyValue HKEY_CURRENT_USER, _
        "Control Panel\Desktop\WindowMetrics", _
        "Shell Icon Size", txtSize.Text

    ' Send HWND_BROADCAST to refresh the icons.
    SendMessageTimeout HWND_BROADCAST, WM_SETTINGCHANGE, _
        SPI_SETNONCLIENTMETRICS, 0&, SMTO_ABORTIFHUNG, _
        10000&, result
End Sub

Private Sub Form_Load()
    ' Get the initial icon size.
    txtSize.Text = GetRegKeyValue( _
        HKEY_CURRENT_USER, _
        "Control Panel\Desktop\WindowMetrics", _
        "Shell Icon Size")
End Sub
